/*
 * Created on 06.09.2005 for PIROL
 *
 * SVN header information:
 *  $Author: LBST-PF-3\orahn $
 *  $Rev: 2563 $
 *  $Date: 2006-10-17 14:11:31 +0200 (Di, 17 Okt 2006) $
 *  $Id: ChangeProjectionDialog.java 2563 2006-10-17 12:11:31Z LBST-PF-3\orahn $
 */
package de.fhOsnabrueck.jump.pirol.ui.dialogs;

import javax.swing.JDialog;

import com.vividsolutions.jts.geom.Coordinate;

import de.fhOsnabrueck.jump.pirol.ui.eventHandling.OKCancelListener;
import de.fhOsnabrueck.jump.pirol.ui.panels.ChangeProjectionPanel;
import de.fhOsnabrueck.jump.pirol.ui.panels.OkCancelButtonPanel;
import de.fhOsnabrueck.jump.pirol.ui.tools.ValueChecker;
import de.fhOsnabrueck.jump.pirol.utilities.Properties.PropertiesHandler;
import de.fhOsnabrueck.jump.pirol.utilities.projection.ReprojectionDescription;

/**
 * Dialog to ask the user for parameters for changing the projection of a layer.
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2005),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2563 $
 * 
 */
public class ChangeProjectionDialog extends JDialog implements ValueChecker {

    private static final long serialVersionUID = 4108308074203487118L;

    protected ChangeProjectionPanel changeProjectionPanel = null;
    
    protected OkCancelButtonPanel okCancelPanel = null;
    protected OKCancelListener okCancelListener = null;
    

    
    /**
     * This is the default constructor
     */
    public ChangeProjectionDialog(String title) {
        super();
        this.setModal(true);
        this.setTitle(title);
        
        initialize();
    }
    

    /**
     * This method initializes this
     */
    protected void initialize() {
        this.setSize(ChangeProjectionPanel.preferredDimension.width, 400);
        
        this.changeProjectionPanel = new ChangeProjectionPanel();
        this.getContentPane().add(this.changeProjectionPanel);
        
        this.okCancelPanel = new OkCancelButtonPanel();
        this.okCancelListener = new OKCancelListener(this);
        this.okCancelPanel.addActionListener(this.okCancelListener);
        this.changeProjectionPanel.add(this.okCancelPanel);
        
        this.doLayout();
    }

    public boolean wasOkClicked() {
        return okCancelListener.wasOkClicked();
    }


	public boolean areValuesOk() {
		return changeProjectionPanel.areValuesOk();
	}


	public int getGkZone() {
		return changeProjectionPanel.getGkZone();
	}


	public PropertiesHandler getHelmertParameters() {
		return changeProjectionPanel.getHelmertParameters();
	}


	public String getInputProjection() {
		return changeProjectionPanel.getInputProjection();
	}


	public String getOutputProjection() {
		return changeProjectionPanel.getOutputProjection();
	}


	public void setGkZone(int zone) {
		changeProjectionPanel.setGkZone(zone);
	}


	public void setInputProjection(String ip) {
		changeProjectionPanel.setInputProjection(ip);
	}


	public void setOutputProjection(String op) {
		changeProjectionPanel.setOutputProjection(op);
	}


	public void setPropsHandler(PropertiesHandler propsHandler) {
		changeProjectionPanel.setPropsHandler(propsHandler);
	}


	public ReprojectionDescription getReprojectionDescription(Coordinate exampleCoord) {
		return changeProjectionPanel.getReprojectionDescription(exampleCoord);
	}


	public void setSourceProjectionLabelText(String text) {
		changeProjectionPanel.setSourceProjectionLabelText(text);
	}


	public void setTargetProjectionLabelText(String text) {
		changeProjectionPanel.setTargetProjectionLabelText(text);
	}

    
}
