/*
 * Created on 14.12.2004
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package de.fhOsnabrueck.jump.pirol.ui.dialogs;

import java.awt.BorderLayout;
import java.awt.Color;
import java.awt.Dimension;
import java.awt.Frame;
import java.awt.HeadlessException;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.Box;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JDialog;
import javax.swing.JLabel;
import javax.swing.JSeparator;
import javax.swing.JTextArea;
import javax.swing.JTextField;

import com.vividsolutions.jump.feature.AttributeType;
import com.vividsolutions.jump.feature.FeatureSchema;

import de.fhOsnabrueck.jump.pirol.ui.documents.NumberInputDocument;
import de.fhOsnabrueck.jump.pirol.ui.eventHandling.OKCancelListener;
import de.fhOsnabrueck.jump.pirol.ui.panels.ColorsChooserPanel;
import de.fhOsnabrueck.jump.pirol.ui.panels.OkCancelButtonPanel;
import de.fhOsnabrueck.jump.pirol.ui.tools.DialogTools;
import de.fhOsnabrueck.jump.pirol.ui.tools.ValueChecker;
import de.fhOsnabrueck.jump.pirol.utilities.colors.ColorGenerator;
import de.fhOsnabrueck.jump.pirol.utilities.i18n.PirolPlugInMessages;

/**
 * 
 * TODO: comment class
 *
 * @author Ole Rahn
 * <br>
 * <br>FH Osnabr&uuml;ck - University of Applied Sciences Osnabr&uuml;ck,
 * <br>Project: PIROL (2005),
 * <br>Subproject: Daten- und Wissensmanagement
 * 
 * @version $Rev: 2595 $
 *
 */
public class getNAttributesAndANumber extends JDialog implements ActionListener, ValueChecker {
	
	private static final long serialVersionUID = 8745733284509813104L;

    private double min, max, value;
	private String labelText;
	private JTextArea dullnessBox;
	private JComboBox xAttributeBox, yAttributeBox;
	
	protected OkCancelButtonPanel okCancelPanel = new OkCancelButtonPanel();
    protected OKCancelListener listener = null;
    
    protected ColorsChooserPanel colorPanel = null;
    
	private FeatureSchema attributes;
	private String[] attrStrings;
	private static String xAttrCommand = "choose X", yAttrCommand = "choose Y";
	private String[] attributeStrs;
	private String xAttribute, yAttribute;

	public getNAttributesAndANumber(Frame parentFrame, String titel, boolean modal, double min, double max, String text, FeatureSchema attributes)
			throws HeadlessException {
		super(parentFrame, titel, modal);
		this.min = min;
		this.max = max;
		this.attributes = attributes;
		
		this.attrStrings = new String[this.attributes.getAttributeCount()];
		for ( int i=0; i<this.attributes.getAttributeCount(); i++){
			this.attrStrings[i] = this.attributes.getAttributeName(i) + ", (" + this.attributes.getAttributeType(i) + ")"; 
		}
		
		this.xAttribute = this.attrStrings[0];
		this.yAttribute = this.attrStrings[0];
		this.labelText = text;
		this.value = (this.min+this.max)/2;
		
		this.setupDialog();
	}
	
	private void setupDialog(){
		
		Box vbox = Box.createVerticalBox();
		int defaultStrutSize = 10;
		Dimension textAreaDim = new Dimension(75,20);
		
        this.listener = new OKCancelListener(this);
        this.listener.addValueChecker(this);
        this.okCancelPanel.addActionListener(this.listener);

        this.xAttributeBox = new JComboBox(this.attrStrings);
		this.xAttributeBox.setActionCommand(getNAttributesAndANumber.xAttrCommand);
		this.xAttributeBox.addActionListener(this);
		this.xAttributeBox.setPreferredSize(new Dimension(250,25));
		this.xAttributeBox.setSelectedIndex(0);
		
		this.yAttributeBox = new JComboBox(this.attrStrings);
		this.yAttributeBox.setActionCommand(getNAttributesAndANumber.yAttrCommand);
		this.yAttributeBox.addActionListener(this);
		this.yAttributeBox.setPreferredSize(new Dimension(250,25));
		this.yAttributeBox.setSelectedIndex(0);

		this.dullnessBox = new JTextArea( new NumberInputDocument(), DialogTools.numberToLocalNumberString(this.value), 1, 10 );
		this.dullnessBox.setEditable(true);
		this.dullnessBox.setEnabled(true);
		this.dullnessBox.setMaximumSize(textAreaDim);
		this.dullnessBox.setBorder(BorderFactory.createEtchedBorder());
		Box dBox = Box.createHorizontalBox();
		dBox.add(new JLabel(PirolPlugInMessages.getString("cluster-dullness") + ":"));
		dBox.add(Box.createGlue());
		dBox.add(Box.createHorizontalStrut(10));
		dBox.add(this.dullnessBox);
		
        this.colorPanel = new ColorsChooserPanel();
        this.colorPanel.setAllowChangingTheNumberOfSteps(false);
        
        vbox.add( Box.createVerticalStrut(defaultStrutSize) );
		vbox.add(DialogTools.getPanelWithLabels(this.labelText,50));
		vbox.add( Box.createVerticalStrut(defaultStrutSize) );
        vbox.add( new JSeparator(JSeparator.HORIZONTAL) );
        vbox.add( Box.createVerticalStrut(defaultStrutSize) );
        vbox.add( Box.createGlue() );
        vbox.add(this.xAttributeBox);
        vbox.add( Box.createVerticalStrut(defaultStrutSize) );
        vbox.add(this.yAttributeBox);
        vbox.add( Box.createVerticalStrut(defaultStrutSize) );
        vbox.add( new JSeparator(JSeparator.HORIZONTAL) );
        vbox.add( Box.createVerticalStrut(defaultStrutSize) );
        vbox.add( Box.createGlue() );
        vbox.add( dBox);
        vbox.add( Box.createVerticalStrut(defaultStrutSize) );
        vbox.add( new JSeparator(JSeparator.HORIZONTAL) );
        vbox.add( Box.createVerticalStrut(defaultStrutSize) );
        vbox.add( Box.createGlue() );
        
        vbox.add(this.colorPanel);
        
        vbox.add( Box.createVerticalStrut(defaultStrutSize) );

        this.getContentPane().add(vbox, BorderLayout.CENTER);
        this.getContentPane().add(vbox.add(this.okCancelPanel), BorderLayout.SOUTH);
		this.pack();
		
		this.setVisible(true);
	}
	
	public double getValue() {
		return value;
	}
	
	public String[] getAttributes() {
		this.attributeStrs = new String[]{ this.xAttribute, this.yAttribute };
		return this.attributeStrs;
	}
	
	private boolean checkAttrTypeNonDiscrete(int nr){
		if ( this.attributes.getAttributeType(nr) != AttributeType.INTEGER && this.attributes.getAttributeType(nr) != AttributeType.DOUBLE ){
			return false;
		}
		return true;		
	}
	
	private boolean inputsOk(){
		boolean ok = this.checkAttrTypeNonDiscrete(this.xAttributeBox.getSelectedIndex()) && this.checkAttrTypeNonDiscrete(this.yAttributeBox.getSelectedIndex());
		
		try{
			this.value = DialogTools.localNumberStringToDouble(this.dullnessBox.getText());
			ok = ok && true;
		} catch ( Exception e ){
			this.dullnessBox.setText("NAN");
			ok = ok && false;
		}		
		return ok;
	}

	public void actionPerformed(ActionEvent arg0) {
		
		if (arg0.getSource().getClass() != JButton.class){
			if (arg0.getSource().getClass() == JComboBox.class){
				JComboBox box = (JComboBox) arg0.getSource();
				int nr;
				if ( box.getActionCommand().equals(getNAttributesAndANumber.xAttrCommand) ){
					nr = this.xAttributeBox.getSelectedIndex();
					this.xAttribute = this.attributes.getAttributeName( nr );
				} else if ( box.getActionCommand().equals(getNAttributesAndANumber.yAttrCommand) ){
					nr = this.yAttributeBox.getSelectedIndex();
					this.yAttribute = this.attributes.getAttributeName( nr );
				}
				
			} else if (arg0.getSource().getClass() == JTextField.class){ 
				try{
					this.value = DialogTools.localNumberStringToDouble(this.dullnessBox.getText());
				} catch ( Exception e ){
					this.dullnessBox.setText("NAN");
					return;
				}
			}

		}
	}
	
	public boolean isValueSet() {
		return this.listener.wasOkClicked();
	}

    /**
     *@inheritDoc
     */
    public boolean areValuesOk() {
        try{
            this.value = DialogTools.localNumberStringToDouble(this.dullnessBox.getText());
        } catch ( Exception e ){
            this.dullnessBox.setText("NAN");
            return false;
        }
        return this.inputsOk();
    }

    public ColorGenerator createColorGenerator() {
        return colorPanel.createColorGenerator();
    }

    public Color getColor(int num) {
        return colorPanel.getColor(num);
    }

    public Color[] getColors() {
        return colorPanel.getColors();
    }
    
}
